{% extends "transport/base.html" %}
{% load leaflet_tags transport_utils %}

{% block extrastyle %}
    {{ block.super }}
    {% leaflet_css %}
    <style>#themap { height: 500px; max-width: 800px; }</style>
{% endblock %}
{% block extra_javascript %}
    {{ block.super }}
    {% leaflet_js %}
    <script>
        /* Afficher le trajet sur la carte. */
        window.addEventListener("map:init", (e) => {
            const map = e.detail.map;
            var polyline = null;
            document.querySelectorAll('table').forEach(tbl => {
                let latlngs = eval(tbl.dataset.linecoords);
                console.log(latlngs);
                polyline = L.polyline(latlngs, {color: 'red'}).addTo(map);
            });
            map.fitBounds(polyline.getBounds());
        }, false);
        window.addEventListener('DOMContentLoaded', () => {
            document.querySelectorAll(".edit_distance").forEach(img => img.addEventListener('click', () => {
                img.closest('td').querySelector('form').removeAttribute('hidden');
                img.setAttribute('hidden', true);
            }));
        });
    </script>
{% endblock %}

{% block content %}
<h2>Détails des trajets du transport</h2>

{% for trajet in trajets %}
    <div class="border rounded">
    <table class="table table-sm mt-3" data-linecoords="{{ trajet.route.linestring }}">
        <tr><th>Origine:</th><td>{{ trajet.trajet.origine }}</td></tr>
        <tr><th>Destination:</th><td>{{ trajet.trajet.destination }}</td></tr>
        <tr><th>Durée:</th><td>{{ trajet.trajet.duree_calc }}</td></tr>
        <tr><th>Distance:</th>
            <td><div class="d-flex flex-wrap justify-content-between">
                    {{ trajet.trajet.dist_calc|as_km }}km
                    <img class="icon cursor-pointer edit_distance" src="{% static 'img/edit.svg' %}" title="Modifier cette distance">
                </div>
                {% if trajet.route.distance_calc %}
                    <div><i>distance figée pour ce trajet: {{ trajet.route.distance|as_km }}km</i></div>
                {% endif %}
                <!-- possible distance edition -->
                <form method="POST" class="w-100" hidden>{% csrf_token %}
                    <label for="id_distance_km">Nouvelle distance [km]:</label>
                    <input type="number" name="distance_km" id="id_distance_km" placeholder="1.0" step="0.1" min="0">
                    <button type="submit" class="btn btn-primary" formaction="{% url 'trajet-set-distance' trajet.trajet.pk %}">
                        Distance fixe pour ce trajet uniquement
                    </button>
                    <button type="submit" class="btn btn-primary" formaction="{% url 'trajet-set-fixed-distance' trajet.trajet.pk %}">
                        Distance fixe pour ce trajet et tous les trajets futurs identiques
                    </button>
                </form>
            </td>
        </tr>
    </table>
    </div>
{% endfor %}

{% leaflet_map "map" %}

{% endblock %}
